/*
 * The Clear BSD License
 * Copyright 2017-2018 NXP
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without modification,
 * are permitted (subject to the limitations in the disclaimer below) provided
 *  that the following conditions are met:
 *
 * o Redistributions of source code must retain the above copyright notice, this list
 *   of conditions and the following disclaimer.
 *
 * o Redistributions in binary form must reproduce the above copyright notice, this
 *   list of conditions and the following disclaimer in the documentation and/or
 *   other materials provided with the distribution.
 *
 * o Neither the name of the copyright holder nor the names of its
 *   contributors may be used to endorse or promote products derived from this
 *   software without specific prior written permission.
 *
 * NO EXPRESS OR IMPLIED LICENSES TO ANY PARTY'S PATENT RIGHTS ARE GRANTED BY THIS LICENSE.
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
 * ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
/***********************************************************************************************************************
 * This file was generated by the MCUXpresso Config Tools. Any manual edits made to this file
 * will be overwritten if the respective MCUXpresso Config Tools is used to update this file.
 **********************************************************************************************************************/

#ifndef _PIN_MUX_H_
#define _PIN_MUX_H_

/*!
 * @addtogroup pin_mux
 * @{
 */

/***********************************************************************************************************************
 * API
 **********************************************************************************************************************/

#if defined(__cplusplus)
extern "C" {
#endif

/*!
 * @brief Calls initialization functions.
 *
 */
void BOARD_InitBootPins(void);

/*!
 * @brief Configures pin routing and optionally pin electrical features.
 *
 */
void BOARD_InitPins(void);

/*! @name PORTE25 (number 32), U2[6]/U10[6]/I2C0_SDA
  @{ */
#define BOARD_ACCEL_SDA_PORT PORTE /*!<@brief PORT device name: PORTE */
#define BOARD_ACCEL_SDA_PIN 25U    /*!<@brief PORTE pin index: 25 */
                                   /* @} */

/*! @name PORTE24 (number 31), U2[7]/U10[4]/I2C0_SDA
  @{ */
#define BOARD_ACCEL_SCL_PORT PORTE /*!<@brief PORT device name: PORTE */
#define BOARD_ACCEL_SCL_PIN 24U    /*!<@brief PORTE pin index: 24 */
                                   /* @} */

/*! @name PORTC5 (number 81), U10[11]/INT1_ACCEL
  @{ */
#define BOARD_ACCEL_INT1_GPIO GPIOC /*!<@brief GPIO device name: GPIOC */
#define BOARD_ACCEL_INT1_PORT PORTC /*!<@brief PORT device name: PORTC */
#define BOARD_ACCEL_INT1_PIN 5U     /*!<@brief PORTC pin index: 5 */
                                    /* @} */

/*! @name PORTD1 (number 94), U2[9]/U10[9]/INT2_ACCEL
  @{ */
#define BOARD_ACCEL_INT2_GPIO GPIOD /*!<@brief GPIO device name: GPIOD */
#define BOARD_ACCEL_INT2_PORT PORTD /*!<@brief PORT device name: PORTD */
#define BOARD_ACCEL_INT2_PIN 1U     /*!<@brief PORTD pin index: 1 */
                                    /* @} */

/*!
 * @brief Configures pin routing and optionally pin electrical features.
 *
 */
void BOARD_InitACCEL(void);

#define SOPT5_UART0ODE_DISABLED 0x00u  /*!<@brief UART0 Open Drain Enable: Open drain is disabled on UART0. */
#define SOPT5_UART0RXSRC_UART_RX 0x00u /*!<@brief UART0 Receive Data Source Select: UART_RX pin */
#define SOPT5_UART0TXSRC_UART_TX 0x00u /*!<@brief UART0 Transmit Data Source Select: UART0_TX pin */

/*! @name PORTA2 (number 36), J1[4]/D1/UART1_TX_TGTMCU
  @{ */
#define BOARD_DEBUG_UART_TX_PORT PORTA /*!<@brief PORT device name: PORTA */
#define BOARD_DEBUG_UART_TX_PIN 2U     /*!<@brief PORTA pin index: 2 */
                                       /* @} */

/*! @name PORTA1 (number 35), J1[2]/D0/UART1_RX_TGTMCU
  @{ */
#define BOARD_DEBUG_UART_RX_PORT PORTA /*!<@brief PORT device name: PORTA */
#define BOARD_DEBUG_UART_RX_PIN 1U     /*!<@brief PORTA pin index: 1 */
                                       /* @} */

/*!
 * @brief Configures pin routing and optionally pin electrical features.
 *
 */
void BOARD_InitDEBUG_UART(void);

/*! @name PORTC3 (number 73), SW1
  @{ */
#define BOARD_SW1_GPIO GPIOC /*!<@brief GPIO device name: GPIOC */
#define BOARD_SW1_PORT PORTC /*!<@brief PORT device name: PORTC */
#define BOARD_SW1_PIN 3U     /*!<@brief PORTC pin index: 3 */
                             /* @} */

/*! @name PORTC12 (number 88), SW3
  @{ */
#define BOARD_SW3_GPIO GPIOC /*!<@brief GPIO device name: GPIOC */
#define BOARD_SW3_PORT PORTC /*!<@brief PORT device name: PORTC */
#define BOARD_SW3_PIN 12U    /*!<@brief PORTC pin index: 12 */
                             /* @} */

/*!
 * @brief Configures pin routing and optionally pin electrical features.
 *
 */
void BOARD_InitButtons(void);

/*! @name PORTE29 (number 26), LED_RED
  @{ */
#define BOARD_LED_RED_GPIO GPIOE /*!<@brief GPIO device name: GPIOE */
#define BOARD_LED_RED_PORT PORTE /*!<@brief PORT device name: PORTE */
#define BOARD_LED_RED_PIN 29U    /*!<@brief PORTE pin index: 29 */
                                 /* @} */

/*! @name PORTD5 (number 98), J2[12]/D13/LED_GREEN
  @{ */
#define BOARD_LED_GREEN_GPIO GPIOD /*!<@brief GPIO device name: GPIOD */
#define BOARD_LED_GREEN_PORT PORTD /*!<@brief PORT device name: PORTD */
#define BOARD_LED_GREEN_PIN 5U     /*!<@brief PORTD pin index: 5 */
                                   /* @} */

/*!
 * @brief Configures pin routing and optionally pin electrical features.
 *
 */
void BOARD_InitLEDs(void);

/*! @name PORTB16 (number 62), E1/TSI_ELECTRODE1
  @{ */
#define BOARD_TSI_ELECTRODE_1_PORT PORTB /*!<@brief PORT device name: PORTB */
#define BOARD_TSI_ELECTRODE_1_PIN 16U    /*!<@brief PORTB pin index: 16 */
                                         /* @} */

/*! @name PORTB17 (number 63), E1/TSI_ELECTRODE2
  @{ */
#define BOARD_TSI_ELECTRODE_2_PORT PORTB /*!<@brief PORT device name: PORTB */
#define BOARD_TSI_ELECTRODE_2_PIN 17U    /*!<@brief PORTB pin index: 17 */
                                         /* @} */

/*!
 * @brief Configures pin routing and optionally pin electrical features.
 *
 */
void BOARD_InitTouch(void);

/*! @name USB0_DM (number 11), J10[2]/USB_DM
  @{ */
/* @} */

/*! @name USB0_DP (number 10), J10[3]/USB_DP
  @{ */
/* @} */

/*! @name VREGIN (number 13), J7[2]/KL46Z_REGIN
  @{ */
/* @} */

/*! @name VOUT33 (number 12), C11/VOUT33
  @{ */
/* @} */

/*!
 * @brief Configures pin routing and optionally pin electrical features.
 *
 */
void BOARD_InitUSB(void);

/*! @name PORTB11 (number 61), DS1[12]/LCD-12
  @{ */
#define BOARD_LCD_12_PORT PORTB /*!<@brief PORT device name: PORTB */
#define BOARD_LCD_12_PIN 11U    /*!<@brief PORTB pin index: 11 */
                                /* @} */

/*! @name PORTB10 (number 60), DS1[11]/LCD-11
  @{ */
#define BOARD_LCD_11_PORT PORTB /*!<@brief PORT device name: PORTB */
#define BOARD_LCD_11_PIN 10U    /*!<@brief PORTB pin index: 10 */
                                /* @} */

/*! @name PORTC18 (number 92), DS1[10]/LCD-10
  @{ */
#define BOARD_LCD_10_PORT PORTC /*!<@brief PORT device name: PORTC */
#define BOARD_LCD_10_PIN 18U    /*!<@brief PORTC pin index: 18 */
                                /* @} */

/*! @name PORTE5 (number 6), DS1[9]/LCD-09
  @{ */
#define BOARD_LCD_09_PORT PORTE /*!<@brief PORT device name: PORTE */
#define BOARD_LCD_09_PIN 5U     /*!<@brief PORTE pin index: 5 */
                                /* @} */

/*! @name PORTB8 (number 58), DS1[8]/LCD-08
  @{ */
#define BOARD_LCD_08_PORT PORTB /*!<@brief PORT device name: PORTB */
#define BOARD_LCD_08_PIN 8U     /*!<@brief PORTB pin index: 8 */
                                /* @} */

/*! @name PORTB7 (number 57), DS1[7]/LCD-07
  @{ */
#define BOARD_LCD_07_PORT PORTB /*!<@brief PORT device name: PORTB */
#define BOARD_LCD_07_PIN 7U     /*!<@brief PORTB pin index: 7 */
                                /* @} */

/*! @name PORTB21 (number 67), DS1[6]/LCD-06
  @{ */
#define BOARD_LCD_06_PORT PORTB /*!<@brief PORT device name: PORTB */
#define BOARD_LCD_06_PIN 21U    /*!<@brief PORTB pin index: 21 */
                                /* @} */

/*! @name PORTC17 (number 91), DS1[5]/LCD-05
  @{ */
#define BOARD_LCD_05_PORT PORTC /*!<@brief PORT device name: PORTC */
#define BOARD_LCD_05_PIN 17U    /*!<@brief PORTC pin index: 17 */
                                /* @} */

/*! @name PORTB22 (number 68), DS1[4]/LCD-04
  @{ */
#define BOARD_LCD_04_PORT PORTB /*!<@brief PORT device name: PORTB */
#define BOARD_LCD_04_PIN 22U    /*!<@brief PORTB pin index: 22 */
                                /* @} */

/*! @name PORTB23 (number 69), DS1[3]/LCD-03
  @{ */
#define BOARD_LCD_03_PORT PORTB /*!<@brief PORT device name: PORTB */
#define BOARD_LCD_03_PIN 23U    /*!<@brief PORTB pin index: 23 */
                                /* @} */

/*! @name PORTE4 (number 5), DS1[2]/LCD-02
  @{ */
#define BOARD_LCD_02_PORT PORTE /*!<@brief PORT device name: PORTE */
#define BOARD_LCD_02_PIN 4U     /*!<@brief PORTE pin index: 4 */
                                /* @} */

/*! @name PORTD0 (number 93), DS1[1]/LCD-01
  @{ */
#define BOARD_LCD_01_PORT PORTD /*!<@brief PORT device name: PORTD */
#define BOARD_LCD_01_PIN 0U     /*!<@brief PORTD pin index: 0 */
                                /* @} */

/*!
 * @brief Configures pin routing and optionally pin electrical features.
 *
 */
void BOARD_InitSegment_LCD(void);

/*! @name PORTA19 (number 51), Y1[3]/XTAL_8MHZ
  @{ */
#define BOARD_XTAL0_PORT PORTA /*!<@brief PORT device name: PORTA */
#define BOARD_XTAL0_PIN 19U    /*!<@brief PORTA pin index: 19 */
                               /* @} */

/*! @name PORTA18 (number 50), Y1[1]/EXTAL_8MHZ
  @{ */
#define BOARD_EXTAL0_PORT PORTA /*!<@brief PORT device name: PORTA */
#define BOARD_EXTAL0_PIN 18U    /*!<@brief PORTA pin index: 18 */
                                /* @} */

/*!
 * @brief Configures pin routing and optionally pin electrical features.
 *
 */
void BOARD_InitOSC(void);

/*! @name PORTE25 (number 32), U2[6]/U10[6]/I2C0_SDA
  @{ */
#define BOARD_MAG_SDA_PORT PORTE /*!<@brief PORT device name: PORTE */
#define BOARD_MAG_SDA_PIN 25U    /*!<@brief PORTE pin index: 25 */
                                 /* @} */

/*! @name PORTE24 (number 31), U2[7]/U10[4]/I2C0_SDA
  @{ */
#define BOARD_MAG_SCL_PORT PORTE /*!<@brief PORT device name: PORTE */
#define BOARD_MAG_SCL_PIN 24U    /*!<@brief PORTE pin index: 24 */
                                 /* @} */

/*! @name PORTD1 (number 94), U2[9]/U10[9]/INT2_ACCEL
  @{ */
#define BOARD_MAG_INT2_GPIO GPIOD /*!<@brief GPIO device name: GPIOD */
#define BOARD_MAG_INT2_PORT PORTD /*!<@brief PORT device name: PORTD */
#define BOARD_MAG_INT2_PIN 1U     /*!<@brief PORTD pin index: 1 */
                                  /* @} */

/*!
 * @brief Configures pin routing and optionally pin electrical features.
 *
 */
void BOARD_InitMAG(void);

#if defined(__cplusplus)
}
#endif

/*!
 * @}
 */
#endif /* _PIN_MUX_H_ */

/***********************************************************************************************************************
 * EOF
 **********************************************************************************************************************/
